import sys
#TIS.pyを別フォルダに格納吸う場合は下記のように記載
#sys.path.append("../python-common")

import cv2
import numpy as np
import TIS
import time

# このサンプルはカメラからのイメージ取得とOpenCVで画像処理する一連の処理する方法を記載しています。
# 必要なパッケージ:
# pyhton-opencv
# pyhton-gst-1.0
# tiscamera


Tis = TIS.TIS()
#　DMK 33UX264 Serial: 16710581 、 解像度640x480＠30 fpsで表示する
#　selectDeviceを使ってデバイスをOpenするためコメントアウトしています
#　Tis.openDevice("16710581", 640, 480, "30/1", TIS.SinkFormats.BGRA,True)
#

#selectDeviceを利用することでデバイスの選択、フォーマット、フレームレートをコマンドラインで指定できる
#if not Tis.selectDevice():
#        quit(0)
Tis.openDevice("29910443", 1920, 1080, "30/1", TIS.SinkFormats.BGRA,True)


#Gstreamerでの映像伝送
Tis.Start_pipeline() 

#カメラプロパティのリスト一覧を表示(設定範囲を確認)
Tis.List_Properties()

#Tonemapping
Tis.Set_Property("Tonemapping", True)
Tis.Set_Property("Tonemapping Global Brightness", 0.0)
Tis.Set_Property("Tonemapping Intensity", 1.0)
print("Tonemapping : " ,Tis.Get_Property("Tonemapping").value)
print("Tonemapping Global Brightness : " ,Tis.Get_Property("Tonemapping Global Brightness").value)
print("Tonemapping Intensity : " ,Tis.Get_Property("Tonemapping Intensity").value)



print('Press Esc to stop')
lastkey=0
imagecounter=0
while lastkey != 27:
        #Timeout設定時間（１秒）以内にPCに画像を取得できた場合次の処理へ進む
        if Tis.Snap_image(1) is True:  # Snap an image with one second timeout
                # 画像取得
                image = Tis.Get_image() 
                imagecounter += 1
                filename = "./image{:04}.png".format(imagecounter)
                # Jpeg画像を保存
                cv2.imwrite(filename, image)
        lastkey = cv2.waitKey(10)

# Gstreamerのパイプラインを停止
Tis.Stop_pipeline()
cv2.destroyAllWindows()
print('Program ends')


